# Generated by Django 3.2.13 on 2023-05-14 07:44

from django.db import migrations


def populate_checklisttaskdefinition_ordering(apps, schema):
    """
    Go over all ChecklistDefinitions and iterate over all their task definitions
    and populate new `order` field to maintain original ordering based on
    `created_on` after migration to new ordering system.
    """
    ChecklistDefinition = apps.get_model("workflow", "ChecklistDefinition")
    for checklist_definition in ChecklistDefinition.objects.all():
        checklist_task_definitions = checklist_definition.task_definitions.order_by(
            "created_on"
        )
        current_order = 0
        for checklist_task_definition in checklist_task_definitions:
            checklist_task_definition.order = current_order
            checklist_task_definition.save()
            current_order += 1


class Migration(migrations.Migration):

    dependencies = [
        ("workflow", "0033_auto_20230514_0742"),
    ]

    operations = [
        migrations.RunPython(
            populate_checklisttaskdefinition_ordering,
            reverse_code=migrations.RunPython.noop,
        )
    ]
